--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->---> E&D DECISIONS COMPATIBILITY <---<--

-------------------------------------------
------------[ PROMOTE THEOLOGY ]-----------
-------------------------------------------

local Decision_AW_Samanid_PromoteTheology = {}
	Decision_AW_Samanid_PromoteTheology.Name = "TXT_KEY_DECISION_AW_SAMANID_PROMOTE_THEOLOGY"
	Decision_AW_Samanid_PromoteTheology.Desc = "TXT_KEY_DECISION_AW_SAMANID_PROMOTE_THEOLOGY_DESC"
	HookDecisionCivilizationIcon(Decision_AW_Samanid_PromoteTheology, "CIVILIZATION_AW_SAMANID")
	Decision_AW_Samanid_PromoteTheology.CanFunc = (
		function(pPlayer)
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_SAMANID) then return false, false end
			if load(pPlayer, "Decision_AW_Samanid_PromoteTheology") == true then
				Decision_AW_Samanid_PromoteTheology.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_SAMANID_PROMOTE_THEOLOGY_DESC_ENACTED")
				return false, false, true
			end
			local iCost = math.ceil(500 * iMod) -- Cost in both gold and culture
			Decision_AW_Samanid_PromoteTheology.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_SAMANID_PROMOTE_THEOLOGY_DESC", iCost, iCost)

			if not (Teams[pPlayer:GetTeam()]:IsHasTech(GameInfoTypes.TECH_MATHEMATICS)) then return true, false end
			if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 2) then return true, false end
			if (pPlayer:GetGold() < iCost) then return true, false end
			if (pPlayer:GetJONSCulture() < iCost) then return true, false end
			if (pPlayer:GetCapitalCity() == nil) then return true, false end
			return true, true
		end
		)
	Decision_AW_Samanid_PromoteTheology.DoFunc = (
		function(pPlayer)
			local iCost = math.ceil(500 * iMod)
			pPlayer:ChangeGold(-iCost)
			pPlayer:ChangeJONSCulture(-iCost)
			if not (pPlayer:IsPolicyBranchUnlocked(GameInfoTypes.POLICY_RATIONALISM)) then
				pPlayer:SetPolicyBranchUnlocked(GameInfoTypes.POLICY_BRANCH_RATIONALISM, true)
			end
			if (Teams[pPlayer:GetTeam()]:IsHasTech(GameInfoTypes.TECH_THEOLOGY)) then
				pPlayer:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_MOSQUE, 1)
			end
			pPlayer:SetHasPolicy(GameInfoTypes.POLICY_AW_SAMANID_DECISION_PROMOTE_THEOLOGY, true)
			save(pPlayer, "Decision_AW_Samanid_PromoteTheology", true)
		end
		)

Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_SAMANID, "Decision_AW_Samanid_PromoteTheology", Decision_AW_Samanid_PromoteTheology)

-------------------------------------------
-----------[ FORMALIZE PERSIAN ]-----------
-------------------------------------------

local Decision_AW_Samanid_FormalizePersian = {}
	Decision_AW_Samanid_FormalizePersian.Name = "TXT_KEY_DECISION_AW_SAMANID_FORMALIZE_PERSIAN"
	Decision_AW_Samanid_FormalizePersian.Desc = "TXT_KEY_DECISION_AW_SAMANID_FORMALIZE_PERSIAN_DESC"
	HookDecisionCivilizationIcon(Decision_AW_Samanid_FormalizePersian, "CIVILIZATION_AW_SAMANID")
	Decision_AW_Samanid_FormalizePersian.CanFunc = (
		function(pPlayer)
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_SAMANID) then return false, false end
			if load(pPlayer, "Decision_AW_Samanid_FormalizePersian") == true then
				Decision_AW_Samanid_FormalizePersian.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_SAMANID_FORMALIZE_PERSIAN_DESC_ENACTED")
				return false, false, true
			end
			
			local iCost = math.ceil(300 * iMod)
			Decision_AW_Samanid_FormalizePersian.Desc = Locale.ConvertTextKey("TXT_KEY_DECISION_AW_SAMANID_FORMALIZE_PERSIAN_DESC", iCost)

			if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1) then return true, false end
			if (pPlayer:GetJONSCulture() < iCost) then	return true, false end
			if (pPlayer:GetCapitalCity() == nil) then return true, false end
			if (pPlayer:GetCurrentEra() < GameInfoTypes.ERA_CLASSICAL) then return true, false	end

			return true, true
		end
		)
	Decision_AW_Samanid_FormalizePersian.DoFunc = (
		function(pPlayer)
			local iCost = math.ceil(300 * iMod)
			pPlayer:ChangeJONSCulture(-iCost)
			pPlayer:AddFreeUnit(GameInfoTypes.UNIT_WRITER)
			pPlayer:SetHasPolicy(GameInfoTypes.POLICY_AW_SAMANID_DECISION_FORMALIZE_PERSIAN, true)
			save(pPlayer, "Decision_AW_Samanid_FormalizePersian", true)
		end
		)

Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_SAMANID, "Decision_AW_Samanid_FormalizePersian", Decision_AW_Samanid_FormalizePersian)
			
-------------------------------------------
------------[ AFTERFUNCTIONS ]-------------
-------------------------------------------

GameEvents.TeamTechResearched.Add(
function(iTeam, iTech)
	for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		if (Players[iPlayer] ~= nil) then
			pPlayer = Players[iPlayer]
			if (iTeam == pPlayer:GetTeam()) then
				if (load(pPlayer, "Decision_AW_Samanid_PromoteTheology") == true) and (iTech == (GameInfoTypes.TECH_THEOLOGY)) then
					pPlayer:GetCapitalCity():SetNumRealBuilding(GameInfoTypes.BUILDING_MOSQUE, 1)
				end
			end
		end
	end
end)


