--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->-----> E&D EVENTS COMPATIBILITY <----<--

-------------------------------------------
----------[ PREDEFINED VARIABLES ]---------
-------------------------------------------

Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType = {}
	Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[GameInfoTypes.ERA_MEDIEVAL] 	= GameInfoTypes.UNIT_HORSEMAN
	Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[GameInfoTypes.ERA_RENAISSANCE] 	= GameInfoTypes.UNIT_KNIGHT
	Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[GameInfoTypes.ERA_INDUSTRIAL]	= GameInfoTypes.UNIT_LANCER
	Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[GameInfoTypes.ERA_MODERN] 		= GameInfoTypes.UNIT_CAVALRY

-------------------------------------------
-----------[ UTILITY FUNCTIONS ]-----------
-------------------------------------------

function AW_UnitclassCounter(player, unitclassID)
	local numUnits = 0
	for unit in player:Units() do
		if unit:GetUnitClassType() == unitclassID then
			numUnits = numUnits + 1
		end
	end
	return numUnits
end

function AW_UnitCombatCounter(player, unitCombatType)
	local numUnits = 0
	for unit in player:Units() do
		if unit:GetUnitCombatType() == unitCombatType then
			numUnits = numUnits + 1
		end
	end
	return numUnits
end

function AW_RandomUnitFromUnitclass(player, unitclassID)
	local iUnit = math.random(AW_UnitclassCounter(player, unitclassID))
	local i = 0
	for unit in player:Units() do
		if (unit:GetUnitClassType() == unitclassID) then
			i = i + 1
		end
		if (i == iUnit) then
			return unit
		end
	end
	return nil
end
	

-------------------------------------------
-----------[ DESERTING CAVALRY ]-----------
-------------------------------------------

local Event_AW_Samanid_DesertingCavalry = {}
	Event_AW_Samanid_DesertingCavalry.Name = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY"
	Event_AW_Samanid_DesertingCavalry.Desc = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_DESC"
	Event_AW_Samanid_DesertingCavalry.Weight = 20
	Event_AW_Samanid_DesertingCavalry.CanFunc = (
		function(pPlayer)
			if load(pPlayer, "Event_AW_Samanid_DesertingCavalry") == true then return false end
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_SAMANID) then return false end
			if (pPlayer:GetCurrentEra() < GameInfoTypes.ERA_MEDIEVAL) then return false end
			if (pPlayer:GetCurrentEra() > GameInfoTypes.ERA_MODERN) then return false end
			return true
		end
		)
	Event_AW_Samanid_DesertingCavalry.Outcomes = {}

-->------------> OUTCOME 1 <------------<--
	
	Event_AW_Samanid_DesertingCavalry.Outcomes[1] = {}
		Event_AW_Samanid_DesertingCavalry.Outcomes[1].Name = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_1"
		Event_AW_Samanid_DesertingCavalry.Outcomes[1].Desc = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_1_DESC"
		Event_AW_Samanid_DesertingCavalry.Outcomes[1].CanFunc = (
			function(pPlayer)
				local iReward = 100 * iMod
				Event_AW_Samanid_DesertingCavalry.Outcomes[1].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_1_DESC", iReward)
				return true
			end
			)
		Event_AW_Samanid_DesertingCavalry.Outcomes[1].DoFunc = (
			function(pPlayer)
				local iReward = 100 * iMod
				pPlayer:ChangeGoldenAgeProgressMeter(iReward)
				save(pPlayer, "Event_AW_Samanid_DesertingCavalry", true)
			end
			)

-->------------> OUTCOME 2 <------------<--

	Event_AW_Samanid_DesertingCavalry.Outcomes[2] = {}
		Event_AW_Samanid_DesertingCavalry.Outcomes[2].Name = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_2"
		Event_AW_Samanid_DesertingCavalry.Outcomes[2].Desc = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_2_DESC"
		Event_AW_Samanid_DesertingCavalry.Outcomes[2].CanFunc = (
			function(pPlayer)
				local unitType = Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[pPlayer:GetCurrentEra()]
				local sUnitType = Locale.ConvertTextKey(GameInfo.Units[unitType].Description)
				local numUnits = math.ceil(pPlayer:GetNumCities() / 2)
				Event_AW_Samanid_DesertingCavalry.Outcomes[2].Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_2_DESC", numUnits, sUnitType)
				return true
			end
			)
		Event_AW_Samanid_DesertingCavalry.Outcomes[2].DoFunc = (
			function(pPlayer)			
				local unitType = Event_AW_Samanid_DesertingCavalry_Outcome2_UnitType[pPlayer:GetCurrentEra()]
				local numUnits = math.ceil(pPlayer:GetNumCities() / 2)
				for i = 1, numUnits do
					pPlayer:InitUnit(unitType, pPlayer:GetCapitalCity():GetX(), pPlayer:GetCapitalCity():GetY())
				end
				save(pPlayer, "Event_AW_Samanid_DesertingCavalry", true)
			end
			)

-->------------> OUTCOME 3 <------------<--

	Event_AW_Samanid_DesertingCavalry.Outcomes[3] = {}
		Event_AW_Samanid_DesertingCavalry.Outcomes[3].Name = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_3"
		Event_AW_Samanid_DesertingCavalry.Outcomes[3].Desc = "TXT_KEY_EVENT_AW_SAMANID_DESERTING_CAVALRY_OUTCOME_3_DESC"
		Event_AW_Samanid_DesertingCavalry.Outcomes[3].CanFunc = (
			function(pPlayer)
				return true
			end
			)
		Event_AW_Samanid_DesertingCavalry.Outcomes[3].DoFunc = (
			function(pPlayer)
				for pCity in pPlayer:Cities() do
					local iChance = math.random(1, 3)
					if (iChance ~= 1) then
						pCity:ChangePopulation(math.ceil(pCity:GetPopulation() / 3))
					end
				end
				save(pPlayer, "Event_AW_Samanid_DesertingCavalry", true)
			end
			)
		
Events_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_SAMANID, "Event_AW_Samanid_DesertingCavalry", Event_AW_Samanid_DesertingCavalry)

-------------------------------------------
-----------[ REBELLIOUS GENERAL ]----------
-------------------------------------------

local Event_AW_Samanid_RebelliousGeneral = {}
	Event_AW_Samanid_RebelliousGeneral.Name = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL"
	Event_AW_Samanid_RebelliousGeneral.Desc = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL_DESC"
	Event_AW_Samanid_RebelliousGeneral.Weight = 15
	Event_AW_Samanid_RebelliousGeneral.CanFunc = (
		function(pPlayer)
			if load(pPlayer, "Event_AW_Samanid_RebelliousGeneral") == true then return false end
			if (pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_AW_SAMANID) then return false end
			if (AW_UnitclassCounter(pPlayer, GameInfoTypes.UNITCLASS_GREAT_GENERAL) < 1) then return false end
			return true
		end
		)
	Event_AW_Samanid_RebelliousGeneral.Outcomes = {}

-->------------> OUTCOME 1 <------------<--

	Event_AW_Samanid_RebelliousGeneral.Outcomes[1] = {}
		Event_AW_Samanid_RebelliousGeneral.Outcomes[1].Name = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL_OUTCOME_1"
		Event_AW_Samanid_RebelliousGeneral.Outcomes[1].Desc = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL_OUTCOME_1_DESC"
		Event_AW_Samanid_RebelliousGeneral.Outcomes[1].CanFunc = (
			function(pPlayer)
				if (AW_UnitCombatCounter(pPlayer, GameInfoTypes.UNITCOMBAT_MOUNTED) < 1) then return false end
				return true
			end
			)
		Event_AW_Samanid_RebelliousGeneral.Outcomes[1].DoFunc = (
			function(pPlayer)
				for pUnit in pPlayer:Units() do
					if (pUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MOUNTED) then
						pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_IGNORES_GREAT_GENERAL, true)
					end
				end
			end
			)

-->------------> OUTCOME 2 <------------<--

	Event_AW_Samanid_RebelliousGeneral.Outcomes[2] = {}
		Event_AW_Samanid_RebelliousGeneral.Outcomes[2].Name = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL_OUTCOME_2"
		Event_AW_Samanid_RebelliousGeneral.Outcomes[2].Desc = "TXT_KEY_EVENT_AW_SAMANID_REBELLIOUS_GENERAL_OUTCOME_2_DESC"
		Event_AW_Samanid_RebelliousGeneral.Outcomes[2].CanFunc = (
			function(pPlayer)
				return true
			end
			)
		Event_AW_Samanid_RebelliousGeneral.Outcomes[2].DoFunc = (
			function(pPlayer)
				local targetUnit = AW_RandomUnitFromUnitclass(pPlayer, GameInfoTypes.UNITCLASS_GENERAL)
				targetUnit:Kill()
				for pCity in pPlayer:Cities() do
					pCity:ChangeResistanceTurns(1)
				end
			end
			)

Events_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_AW_SAMANID, "Event_AW_Samanid_RebelliousGeneral", Event_AW_Samanid_RebelliousGeneral)

			



						
				
				
			
				
				
				
		
	
	
	